let gulp = require('gulp');
let run = require('gulp-run');

let modules = [
    'sk-core',
    'sk-input',
    'sk-input-jquery',
    'sk-button',
    'sk-button-jquery',
    'sk-alert',
    'sk-alert-jquery',
    'sk-accordion',
    'sk-accordion-jquery',
    'sk-app',
    'sk-app-jquery',
    'sk-checkbox',
    'sk-checkbox-jquery',
    'sk-datepicker',
    'sk-datepicker-jquery',
    'sk-dialog',
    'sk-dialog-jquery',
    'sk-form',
    'sk-form-jquery',
    'sk-navbar',
    'sk-navbar-jquery',
    'sk-select',
    'sk-select-jquery',
    'sk-spinner',
    'sk-spinner-jquery',
    'sk-switch',
    'sk-switch-jquery',
    'sk-tabs',
    'sk-tabs-jquery',
    'sk-tree',
    'sk-theme-jquery',
    'gridy-grid',
    'gridy-grid-default',
    'gridy-grid-jquery',
    'gridy-grid-antd'
];


/**
 * watches set of bundle source packages, rebuild bundle and hotdeploy (replace files) to stand
 * when changed
 */
function watch() {
    let watches = [];
    for (let module of modules) {
        watches.push(`../${module}/**/*`);
    }
    let watcher = gulp.watch(watches);
    watcher.on('change', function(path) {
        let pathParts = path.split('/').slice(1, -1);
        console.log(`File ${path} was changed, new path will be copied to ./node_modules/${pathParts.join('/')}`);
        gulp.src(path).pipe(gulp.dest(['./node_modules/', ...pathParts].join('/')));
    });
}

exports.watch = watch;
